-- Deploy camper:campsite_carousel to pg
-- requires: roles
-- requires: schema_camper
-- requires: campsite
-- requires: media
-- requires: user_profile

begin;

set search_path to camper, public;

create table campsite_carousel (
	campsite_id integer not null references campsite,
	media_id integer not null references media,
	caption text not null,
	position integer not null default 2147483647,
	primary key (campsite_id, media_id)
);

grant select on table campsite_carousel to guest;
grant select on table campsite_carousel to employee;
grant select, insert, update, delete on table campsite_carousel to admin;

alter table campsite_carousel enable row level security;

create policy guest_ok
on campsite_carousel
for select
using (true)
;

create policy insert_to_company
on campsite_carousel
for insert
with check (
	exists (select 1 from campsite join media using (company_id) join user_profile using (company_id) where campsite.campsite_id = campsite_carousel.campsite_id and media.media_id = campsite_carousel.media_id)
)
;

create policy update_company
on campsite_carousel
for update
using (
	exists (select 1 from campsite join media using (company_id) join user_profile using (company_id) where campsite.campsite_id = campsite_carousel.campsite_id and media.media_id = campsite_carousel.media_id)
)
;

create policy delete_from_company
on campsite_carousel
for delete
using (
	exists (select 1 from campsite join media using (company_id) join user_profile using (company_id) where campsite.campsite_id = campsite_carousel.campsite_id and media.media_id = campsite_carousel.media_id)
)
;

commit;
